#ifndef COMMIODEVICE_H
#define COMMIODEVICE_H

#include <QByteArray>

// 通讯接口
class CommIODevice
{
public:
    CommIODevice();
    virtual ~CommIODevice();

    // 0: ascii,1: unicode
    int protocol() const;

    virtual bool isAvailable() const = 0;

    virtual bool canRead() const = 0;
    virtual bool canWrite() const = 0;

    virtual QByteArray readAll() const;
    virtual int write(const QByteArray &bytes) = 0;

protected:
    int _protocol;
    QByteArray _readBytes;
};

#endif // COMMIODEVICE_H
