#ifndef NETWORKBROADCASTDIALOG_H
#define NETWORKBROADCASTDIALOG_H

#include <QDialog>
#include <QTimer>

class QUdpSocket;

// 广播搜索板卡对话框
class NetworkBroadcastDialog : public QDialog
{
    Q_OBJECT
public:
    NetworkBroadcastDialog(QWidget *parent = 0);
    ~NetworkBroadcastDialog();

    QString ipAddr() const { return _ipAddr; }
    int port() const { return _port; }
    bool isUnicode() const { return _isUnicode; }

    virtual int exec();

protected slots:
    void slotOnSearch();
    void slotOnBroadcastDatagram();

private:
    void finishSearch(int result);
    void readDeviceFromDatagram(const QByteArray &bytes);

    QString _deviceName;
    QString _ipAddr;
    int _port;
    bool _isUnicode;
    QString _deviceID;

    QTimer _searchTimer;
    int _repeatCount;
    QUdpSocket *_p_broadcastSocket;
};

#endif // NETWORKBROADCASTDIALOG_H
