#ifndef NETWORKWDIGET_H
#define NETWORKWDIGET_H

#include <QWidget>
#include <QTimer>

#include "commiodevice.h"

class QLineEdit;
class QPushButton;
class QComboBox;
class QTcpSocket;

// 网口参数设置界面，并继承通讯接口CommIODevice，实现网口读写
class NetworkWdiget : public QWidget,public CommIODevice
{
    Q_OBJECT
public:
    NetworkWdiget(QWidget *parent = 0);
    virtual ~NetworkWdiget();

    virtual bool isAvailable() const;

    virtual bool canRead() const;
    virtual bool canWrite() const;

    virtual int write(const QByteArray &bytes);

protected slots:
    void slotOnDoConnect();
    void slotOnDoDisconnect();
    void slotOnSearch();

    void slotOnModeChanged();

    void slotOnTimeout();

    void doRead();

signals:
    void readyRead();

    void connected();
    void disconnected();

private:
    void updateState();

    QLineEdit *_p_ipEdit;
    QLineEdit *_p_portEdit;
    QPushButton *_p_connectBtn;
    QPushButton *_p_disconnectBtn;
    QPushButton *_p_broadcastBtn;
    QComboBox *_p_modeCbx;

    QTimer _timer;
    QTcpSocket *_p_socket;
};

#endif // NETWORKWDIGET_H
