#ifndef SERIALPORTWIDGET_H
#define SERIALPORTWIDGET_H

#include <QWidget>
#include <QTimer>

#include "commiodevice.h"

class QSerialPort;
class QComboBox;
class QPushButton;

// 串口参数设置界面，并继承通讯接口CommIODevice，实现串口读写
class SerialPortWidget : public QWidget,public CommIODevice
{
    Q_OBJECT
public:
    SerialPortWidget(QWidget *parent = 0);
    virtual ~SerialPortWidget();

    virtual bool isAvailable() const;

    virtual bool canRead() const;
    virtual bool canWrite() const;

    virtual int write(const QByteArray &bytes);

protected slots:
    void slotOnTimeout();

    void slotOnModeChanged();
    void doOpen();
    void doClose();

    void doRead();

signals:
    void readyRead();

    void connected();
    void disconnected();

private:
    void updateState();

    QTimer _timer;

    QComboBox *_p_portCbx;
    QComboBox *_p_baudrateCbx;
    QComboBox *_p_databitCbx;
    QComboBox *_p_paritybitCbx;
    QComboBox *_p_stopbitCbx;
    QComboBox *_p_modeCbx;

    QPushButton *_p_openBtn;
    QPushButton *_p_closeBtn;

    QSerialPort *_p_serialport;
};

#endif // SERIALPORTWIDGET_H
